Plugin.extend({
    _type: 'nRandomGenerator',
    /**
     * @author Swati Singh
     */

    /**
     * take dividend range and divisior arrary as input
     * Generates random number as divided within the given range
     * Selects a random number from the given divisior array
     **/


    initPlugin: function(data) {
        console.log(data);
        var controller = this._stage.getController("item");
        if (controller) {
            this._controller = controller;
        }

        this._self = new createjs.Container();
        var dims = this.relativeDims();
        this._self.x = dims.x;
        this._self.y = dims.y;
        var num1 = [];
        var num2 = [];
        if (isNaN(data.dividend)) {
            num1 = this._stage.getModelValue(data.dividend);
        } else {
            num1 = data.dividend;
        }
        var dividenRrange = num1.split("-");
        if (isNaN(data.divisior)) {
            num2 = this._stage.getModelValue(data.divisior);
        } else {
            num2 = data.divisior;
        }
        if (num1.length > 0 && num2.length > 0) {
            var divisiorArray = num2.split(",");
            var randomNo1, randomNo2;
            var quotient, remainder;

            /**
             * This condition checks if dividend and divisior is already generated or not.
             * If not then it will generate dividend from the given range and pich random divisior 
             * from the fiven set of divisiors. If already generated it will take the previous value. 
             **/


            if (!this._controller.getModelValue("isNumberSet")) {
                this._controller.setModelValue("isNumberSet", true);
                if (parseInt(dividenRrange[0]) > 0 && parseInt(dividenRrange[1]) > parseInt(dividenRrange[0]) && parseInt(dividenRrange[1]) <= 9999) {
                    // fuction call to generate random number
                    randomNo1 = this.generateRandomNumber(dividenRrange);
                }
                randomNo2 = divisiorArray[Math.floor(Math.random() * divisiorArray.length)];
                if (!this._controller.getModelValue("isRemainder")) {
                    quotient = Math.floor(randomNo1 / randomNo2);
                    randomNo1 = randomNo2 * quotient;
                    remainder = randomNo1 % randomNo2;
                    this._controller.setModelValue("ranDigit1", (randomNo1));
                    this._controller.setModelValue("ranDigit2", (randomNo2));
                } else {
                    quotient = Math.floor(randomNo1 / randomNo2);
                    remainder = randomNo1 % randomNo2;
                    this._controller.setModelValue("ranDigit1", (randomNo1));
                    this._controller.setModelValue("ranDigit2", (randomNo2));
                }
            }

            //Setting remainder and quotient as answer
            var preAnswerObj = this._controller.getModelValue("answer");
            preAnswerObj.ans1.value = quotient;
            if(preAnswerObj.ans2==undefined){
                preAnswerObj.ans2={};
                preAnswerObj.ans2.value = remainder;
                preAnswerObj.ans2.score = 1;
            }
            else{
                preAnswerObj.ans2.value = remainder;
            }
            this._controller.setModelValue("answer", preAnswerObj);

            /****************Start of Invoking the question data on stage****************/

            var dividendData = Object.create(data);
            dividendData.id = _.unique("dividendDataId");
            dividendData.color = "#4c4c4c";
            dividendData.fontsize = "5vw";
            dividendData.align = "right";
            dividendData.$t = this._controller.getModelValue("ranDigit1");
            dividendData.w = data.w / 5;
            dividendData.x = data.x + 25;
            dividendData.y = data.y;
            dividendData.h = data.h;
            PluginManager.invoke('text', dividendData, this, this._stage, this._theme);

            var operator1 = Object.create(data);
            operator1.id = _.unique("operator1Id");
            operator1.align = "center";
            operator1.color = "#4c4c4c";
            operator1.fontsize = "5vw";
            operator1.$t = "\u00F7";
            operator1.w = data.w / 20;
            operator1.x = dividendData.w + dividendData.x + 5;
            operator1.y = data.y;
            operator1.h = data.h;
            PluginManager.invoke('text', operator1, this, this._stage, this._theme);

            var divisiorData = Object.create(data);
            divisiorData.id = _.unique("divisiorDataId");
            divisiorData.color = "#4c4c4c";
            divisiorData.fontsize = "5vw";
            divisiorData.align = "left";
            divisiorData.$t = this._controller.getModelValue("ranDigit2");;
            divisiorData.w = data.w / 5;
            divisiorData.x = operator1.w + operator1.x + 5;
            divisiorData.y = data.y;
            divisiorData.h = data.h;
            PluginManager.invoke('text', divisiorData, this, this._stage, this._theme);

            var quotientText = Object.create(data);
            quotientText.id = _.unique("quotientTextId");
            quotientText.color = "#4c4c4c";
            quotientText.align = "center";
            quotientText.fontsize = "4vw";
            quotientText.$t = "Quotient :";
            quotientText.w = data.w / 4;
            quotientText.x = data.x;
            quotientText.y = data.y + 40;
            quotientText.h = data.h;
            PluginManager.invoke('text', quotientText, this, this._stage, this._theme);

            var quotientBox = Object.create(data);
            quotientBox.id = _.unique("quotientBoxId");
            quotientBox.type = "rect";
            quotientBox.hitArea = true;
            quotientBox.x = quotientText.w + quotientText.x;
            quotientBox.y = data.y + 30;
            quotientBox.h = data.h / 4;
            quotientBox.w = data.w / 4;
            PluginManager.invoke('shape', quotientBox, this, this._stage, this._theme);

            var quotientline = Object.create(data);
            quotientline.id = _.unique("quotientlineId");
            quotientline.type = "rect";
            quotientline.stroke = "#4c4c4c";
            quotientline.hitArea = true;
            quotientline.x = quotientText.w + quotientText.x;
            quotientline.y = data.y + 55;
            quotientline.h = 0;
            quotientline.w = data.w / 4;
            PluginManager.invoke('shape', quotientline, this, this._stage, this._theme);

            var remainderText = Object.create(data);
            remainderText.id = _.unique("itemText4Id");
            remainderText.color = "#4c4c4c";
            remainderText.align = "center";
            remainderText.fontsize = "4vw";
            remainderText.$t = "Remainder :";
            remainderText.w = data.w / 3;
            remainderText.x = quotientline.w + quotientline.x;
            remainderText.y = data.y + 40;
            remainderText.h = data.h;
            PluginManager.invoke('text', remainderText, this, this._stage, this._theme);

            var remainderBox = Object.create(data);
            remainderBox.id = _.unique("remainderBoxId");
            remainderBox.type = "rect";
            remainderBox.hitArea = true;
            remainderBox.x = remainderText.w + remainderText.x;
            remainderBox.y = data.y + 30;
            remainderBox.h = data.h / 3.3;
            remainderBox.w = data.w / 4;
            PluginManager.invoke('shape', remainderBox, this, this._stage, this._theme);


            var remainderline = Object.create(data);
            remainderline.id = _.unique("remainderlineId");
            remainderline.type = "rect";
            remainderline.stroke = "#4c4c4c";
            remainderline.hitArea = true;
            remainderline.x = remainderText.w + remainderText.x;
            remainderline.y = data.y + 55;
            remainderline.h = 0;
            remainderline.w = data.w / 4;
            PluginManager.invoke('shape', remainderline, this, this._stage, this._theme);

            /*****************End of Invoking the question data on stage*****************/
        }
    },
    generateRandomNumber: function(num) {
        var min = parseInt(num[0]);
        var max = parseInt(num[1]);
        var result = _.random(min, max);
        return result;
    }
});
